
dim KK as double = 1.5			' Coefficent				( 1.3 or 1.5 )

dim W_mm as double = 17.78		' Width of chamber			( mm )
dim H_mm as double = 5.08		' Height of chamber			( mm )
dim V_mm as double				' Volume of chamber 		( mm cubical )
'
dim D_mm as double = 6			' Emission hole diameter	( mm )
dim L_mm as double = 1.27		' Emission hole thickness	( mm ) 
dim C_mm as double = 344000		' Speed of sound 			( mm / sec )
'
dim F as double					' Resonant frequency		( Hz )


sub CalcVolume
	dim r as double = W_mm / 2
	V_mm = H_mm * PI * r * r
end sub

sub Formula_1()
	dim c as double = C_mm * 0.1			' Speed of sound 		( cm/sec )
	dim a as double = (D_mm / 2) * 0.1		' Hole radius			( cm )
	dim l as double = L_mm * 0.1			' Wall thickness		( cm )
	dim v as double = V_mm / 1000			' Volume				( cm cubical )

	F = ( c / ( 2 * PI ) ) * sqrt ( ( PI * a * a ) / ( v * ( l + KK * a ) ) )
end sub

sub Formula_2()
	dim c as double = C_mm * 0.1			' Speed of sound  		( cm/sec )
	dim a as double = (D_mm / 2) * 0.1		' Hole radius 			( cm )
	dim l as double = L_mm * 0.1			' Wall thickness		( cm )
	dim d as double = W_mm * 0.1			' Diameter of rim		( cm )
	dim h as double = H_mm * 0.1			' Height of chamber		( cm )
	
	F = ( c / ( 2 * PI ) ) * sqrt ( ( 4 * a * a ) / ( d * d * h * ( l + KK * a ) ) )
end sub

sub Formula_3() 	
	F = ( ( C_mm * D_mm ) / ( 2 * PI * W_mm ) ) * sqrt ( 1 / ( H_mm * ( L_mm + 0.75 * D_mm ) ) )
end sub

sub Formula_4() 
	F = ( ( C_mm * D_mm ) / 4 ) * sqrt ( 1 / ( PI * V_mm * ( L_mm + 0.75 * D_mm ) ) )
end sub


' Symbolic manipulations
' A computer algebra system (CAS) is a software program </wiki/Application_software>
' that facilitates symbolic mathematics </wiki/Symbolic_mathematics>. 
' The core functionality of a CAS is manipulation of mathematical expressions in symbolic form.

' Derive6  - Texas Instruments - Version 6.10
' Reduce - Sourceforge - 


' =========================================================================================
'   Program execution
' =========================================================================================

sub Main(ByVal params() As String)
	CalcVolume
	dim s as string = ""
	'
	Formula_1
	s &= "Formula_1 = " & F.tostring() & vbcrlf
	'
	Formula_2
	s &= "Formula_2 = " & F.tostring() & vbcrlf
	'
	Formula_3
	s &= "Formula_3 = " & F.tostring() & vbcrlf
	'
	Formula_4
	s &= "Formula_4 = " & F.tostring() & vbcrlf
	'
	messagebox.show(s, "Calcolo buzzer")
End Sub

