
Imports Microsoft.VisualBasic
Imports System.Math
Imports System
Imports System.Windows.Forms
Imports System.Diagnostics
Imports System.Collections.Generic	' ( lists )
Imports System.Runtime.InteropServices

Public Class Script
	Public Shared Sub Main(ByVal s() As String)
		If s.length > 0 Then
			Select Case s(0)
				'Case "1": Strato3
				'Case "2": Strato1
			End Select
		Else
			Strato4
			'Strato3
	
		End If
	End Sub
End Class




Module Gcode

	' =========================================================================
	'   USER FUNCTIONS
	' =========================================================================

	' --------- MILL 500 ---------------
	' X = 134 mm ( 125mm sicuri) 
	' Y = 82 mm  ( 75 sicuri )  
	' Z = 80 mm ( meno spessore e varie )

	' --------- punte proxxon ----------
	' diametro 0.8 mm oppure 0.6 mm
	' parte cilindrica 3 mm
	' angolo 120 gradi


	
	Const Tool_Diam As Double = 0.8

	Const ExtWidth As Double = 50
	Const ExtHeight As Double = 40
	Const HolesDiam As Double = 3
	Const DistHoleBorder As Double = 4
		
	Const Cw As Double = 10
	Const Ch As Double = 10
	Const Cnx As Int32 = 3
	Const Cny As Int32 = 3
	Const Csep As Double = 1

	Friend Sub Strato3()
		' ------------------------------------------------------------------ inizializzazione
		SetFileName("Strato3.gc")
		SetMaxValues(250, 60)
		SetStock(ExtWidth, ExtHeight, 1.6)
		SetRapidFeed(250)
		SetTool(Tool_Diam, 120)
		Start()
		' ------------------------------------------------------------------ inizio lavorazione
		SetSpeed(20000)

		' ------------------------------------------------------------------ cave rettangolari
		Dim LeftSpace As Single = (ExtWidth - Cnx * Cw - (Cnx - 1) * Csep) / 2
		Dim BottomSpace As Single = (ExtHeight - Cny * Ch - (Cny - 1) * Csep) / 2
		For x As Int32 = 0 To Cnx - 1
			For y As Int32 = 0 To Cny - 1
				Rectangle(LeftSpace + (Cw+Csep) * x, BottomSpace + (Ch+Csep) * y, Cw, Ch)
			Next
		Next
		
		' ------------------------------------------------------------------ quattro fori agli angoli 
		Hole(DistHoleBorder, DistHoleBorder, HolesDiam)
		Hole(ExtWidth - DistHoleBorder, DistHoleBorder, HolesDiam)
		Hole(ExtWidth - DistHoleBorder, ExtHeight- DistHoleBorder, HolesDiam)
		Hole(DistHoleBorder, ExtHeight- DistHoleBorder, HolesDiam)
		
		' ------------------------------------------------------------------ rettangolo esterno
		Rectangle(0, 0, ExtWidth, ExtHeight)
		
		' ------------------------------------------------------------------ chiusura
		Finish()
	End Sub
	
	Friend Sub Strato4()
		' ------------------------------------------------------------------ inizializzazione
		SetFileName("Strato4.gc")
		SetMaxValues(250, 60)
		SetStock(ExtWidth, ExtHeight, 1.6)
		SetRapidFeed(250)
		SetTool(Tool_Diam, 120)
		Start()
		' ------------------------------------------------------------------ inizio lavorazione
		SetSpeed(20000)
		
		' ------------------------------------------------------------------ cava rettangolare unica
		Dim LeftSpace As Single = (ExtWidth - Cnx * Cw - (Cnx - 1) * Csep - Tool_Diam) / 2
		Dim BottomSpace As Single = (ExtHeight - Cny * Ch - (Cny - 1) * Csep - Tool_Diam) / 2
		Rectangle(LeftSpace, BottomSpace, + (Cw+Csep) * Cnx, + (Ch+Csep) * Cny)

		' ------------------------------------------------------------------ quattro fori agli angoli 
		Hole(DistHoleBorder, DistHoleBorder, HolesDiam)
		Hole(ExtWidth - DistHoleBorder, DistHoleBorder, HolesDiam)
		Hole(ExtWidth - DistHoleBorder, ExtHeight- DistHoleBorder, HolesDiam)
		Hole(DistHoleBorder, ExtHeight- DistHoleBorder, HolesDiam)
		
		' ------------------------------------------------------------------ rettangolo esterno
		Rectangle(0, 0, ExtWidth, ExtHeight)
		
		' ------------------------------------------------------------------ chiusura
		Finish()
	End Sub




	' =========================================================================
	'   UTILITY FUNCTIONS
	' =========================================================================

	Friend Sub Hole(ByVal x As Double, ByVal y As Double, ByVal diam As Double)
		SetFeed(100)
		SetSpeed(20000)
		RapidTo(2)
		RapidTo(x, y)
		MoveTo(-2)
		For a As Int32 = 0 To 360 Step 10
			Dim rad As Double = a * (2 * PI) / 360
			MoveTo(x + 0.5 * diam * Sin(rad) , y + 0.5 * diam * Cos(rad),  -2)
		Next
	End Sub
	
	Friend Sub Rectangle(ByVal x As Double, ByVal y As Double, ByVal w As Double, ByVal h As Double)
		SetFeed(100)
		SetSpeed(20000)
		RapidTo(2)
		RapidTo(x, y)
		MoveTo(-2)
		MoveTo(x + w, y)
		MoveTo(x + w, y + h)
		MoveTo(x, y + h)
		MoveTo(x, y)
	End Sub




	' =========================================================================
	'   GCODE FUNCTIONS
	' =========================================================================


	Private CoordFormat As String = "0.000"

	Private FileName As String

	Private old_X As Double
	Private old_Y As Double
	Private old_Z As Double

	Private TotTime As Double
	Private TotRapid As Double
	Private TotMove As Double

	Private MaxFeedX As Double
	Private MaxFeedY As Double
	Private MaxFeedZ As Double

	Private RampX As Double
	Private RampY As Double
	Private RampZ As Double

	Private WorkFeed As Double
	Private WorkSpeed As Double
	Private RapidFeed As Double

	Private ToolDiam As Double
	Private ToolAngle As Double

	Private stock_dx As Double
	Private stock_dy As Double
	Private stock_dz As Double

	Private stock_ox As Double
	Private stock_oy As Double
	Private stock_oz As Double

	Private Gcode As List(Of String)


	Private Function CalcTime(ByVal delta As Double, ByVal feed As Double, ByVal ramp As Double) As Double
		Dim t As Double = (delta * 60.0) / feed
		If delta > 0 Then t += 0.42 * (feed / 60.0) / ramp
		Return t
	End Function

	Private Sub File_KillFile(ByRef FileName As String)
		On Error Resume Next
		If Not My.Computer.FileSystem.FileExists(FileName) Then Exit Sub
		SetAttr(FileName, FileAttribute.Normal)
		Kill(FileName)
	End Sub

	Private Function FormatNum(ByVal n As Double) As String
		Return n.ToString(CoordFormat).Replace(",", ".")
	End Function

	' ------------------------------------------------------------- PUBLIC

	Friend Sub Start()
		Gcode = New List(Of String)

		TotTime = 0
		TotRapid = 0
		Gcode.Clear()
		Gcode.Add("")
		Gcode.Add("(MCUSTOCK X" & FormatNum(stock_dx) & _
						" Y" & FormatNum(stock_dy) & _
						" Z" & FormatNum(stock_dz) & _
						" OTL" & _
						" OX" & FormatNum(stock_ox) & _
						" OY" & FormatNum(stock_oy) & _
						" OZ" & FormatNum(stock_oz) & ")")
		Gcode.Add("")
		Gcode.Add("G21")
		Gcode.Add("G90")
		Gcode.Add("G40")
		Gcode.Add("M03")
		Gcode.Add("")
		Gcode.Add("(MCUTOOL T13 D" & FormatNum(ToolDiam) & " F3 L30 A" & FormatNum(ToolAngle))
		Gcode.Add("M06 T13")
		Gcode.Add("")
	End Sub

	Friend Sub Finish()
		Gcode.Add("")
		Gcode.Add("(==============================)")
		Gcode.Add("( END OF PROGRAM               )")
		Gcode.Add("M05")
		Gcode.Add("G00 Z0.500")
		RapidTo(2)
		RapidTo(0, 0, 20)
		Gcode.Add("M30")
		Gcode.Add("M02")
		Gcode.Add("(==============================)")
		Gcode.Add("")
		Gcode.Add("(======= STATISTICS =======)")
		Gcode.Add("( Total Rapid " & TotRapid.ToString("0") & " mm")
		Gcode.Add("( Total Move " & TotMove.ToString("0") & " mm")
		Gcode.Add("")
		Gcode.Add("( Total estimated time:")
		'
		Dim h As Integer = CInt(Floor(TotTime / 3600))
		TotTime -= h * 3600
		Dim m As Integer = CInt(Floor(TotTime / 60.0))
		TotTime -= m * 60
		Dim sec As Integer = CInt(TotTime)
		'
		If h > 0 Then Gcode.Add("( " & h.ToString & " hours")
		If m > 0 Then Gcode.Add("( " & m.ToString & " min.")
		Gcode.Add("( " & sec.ToString & " sec.")
		Gcode.Add("")
		'
		Dim f As String = Environment.GetFolderPath(Environment.SpecialFolder.MyDocuments) & "\" & FileName

		File_KillFile(f)
		Dim file As IO.StreamWriter = My.Computer.FileSystem.OpenTextFileWriter(f, False, System.Text.Encoding.ASCII)
		For Each s As String In Gcode
			file.WriteLine(s & vbCr)
		Next
		file.Close()

		Process.Start(f)
	End Sub


	Friend Sub SetFileName(ByVal _FileName As String)
		FileName = _FileName
	End Sub

	Friend Sub SetMaxValues(ByVal MaxFeed As Double, ByVal Ramp As Double)
		MaxFeedX = MaxFeed
		MaxFeedY = MaxFeed
		MaxFeedZ = MaxFeed
		RampX = Ramp
		RampY = Ramp
		RampZ = Ramp
	End Sub

	Friend Sub SetStock(ByVal x As Double, ByVal y As Double, ByVal z As Double)
		stock_dx = x
		stock_dy = y
		stock_dz = z
	End Sub

	Friend Sub SetRapidFeed(ByVal _RapidFeed As Double)
		RapidFeed = _RapidFeed
	End Sub

	Friend Sub SetFeed(ByVal _WorkFeed As Double)
		WorkFeed = _WorkFeed
		Gcode.Add("F " & WorkFeed.ToString)
	End Sub

	Friend Sub SetSpeed(ByVal _WorkSpeed As Double)
		WorkSpeed = _WorkSpeed
		Gcode.Add("S " & WorkSpeed.ToString)
	End Sub

	Friend Sub SetTool(ByVal _ToolDiam As Double, ByVal _ToolAngle As Double)
		ToolDiam = _ToolDiam
		ToolAngle = _ToolAngle
	End Sub




	Friend Sub RapidTo(ByVal x As Double, ByVal y As Double, ByVal z As Double)
		If x <> old_X Or y <> old_Y Or z <> old_Z Then
			'
			Dim delta As Double
			'
			If Abs(z - old_Z) > Abs(x - old_X) And Abs(z - old_Z) > Abs(y - old_Y) Then
				delta = Abs(z - old_Z)
				TotTime += CalcTime(delta, MaxFeedZ, RampZ)
			Else
				If Abs(x - old_X) > Abs(y - old_Y) Then
					delta = Abs(x - old_X)
					TotTime += CalcTime(delta, MaxFeedX, RampX)
				Else
					delta = Abs(y - old_Y)
					TotTime += CalcTime(delta, MaxFeedY, RampY)
				End If
			End If
			'
			TotRapid += delta
			'
			old_X = x
			old_Y = y
			old_Z = z
			'
			Gcode.Add("G00 X" & FormatNum(x) & " Y" & FormatNum(y) & " Z" & FormatNum(z))
		End If
	End Sub

	Friend Sub RapidTo(ByVal x As Double, ByVal y As Double)
		If x <> old_X Or y <> old_Y Then
			'
			Dim delta As Double
			'
			If Abs(x - old_X) > Abs(y - old_Y) Then
				delta = Abs(x - old_X)
				TotTime += CalcTime(delta, MaxFeedX, RampX)
			Else
				delta = Abs(y - old_Y)
				TotTime += CalcTime(delta, MaxFeedY, RampY)
			End If
			'
			TotRapid += delta
			'
			old_X = x
			old_Y = y
			'
			Gcode.Add("G00 X" & FormatNum(x) & " Y" & FormatNum(y))
		End If
	End Sub

	Friend Sub RapidTo(ByVal z As Double)
		'
		Dim delta As Double
		'
		If z <> old_Z Then
			delta = Abs(z - old_Z)
			TotTime += CalcTime(delta, MaxFeedZ, RampZ)
			TotRapid += delta
			'
			old_Z = z
			'
			Gcode.Add("G00 Z" & FormatNum(z))
		End If
	End Sub


	Friend Sub MoveTo(ByVal x As Double, ByVal y As Double, ByVal z As Double)
		If x <> old_X Or y <> old_Y Or z <> old_Z Then
			'
			Dim delta As Double
			'
			If Abs(z - old_Z) > Abs(x - old_X) And Abs(z - old_Z) > Abs(y - old_Y) Then
				delta = Abs(z - old_Z)
				TotTime += CalcTime(delta, MaxFeedZ, RampZ)
			Else
				If Abs(x - old_X) > Abs(y - old_Y) Then
					delta = Abs(x - old_X)
					TotTime += CalcTime(delta, WorkFeed, RampX)
				Else
					delta = Abs(y - old_Y)
					TotTime += CalcTime(delta, WorkFeed, RampY)
				End If
			End If
			'
			TotMove += delta
			'
			old_X = x
			old_Y = y
			old_Z = z
			'
			Gcode.Add("G01 X" & FormatNum(x) & " Y" & FormatNum(y) & " Z" & FormatNum(z))
		End If
	End Sub

	Friend Sub MoveTo(ByVal x As Double, ByVal y As Double)
		If x <> old_X Or y <> old_Y Then
			'
			Dim delta As Double
			'
			If Abs(x - old_X) > Abs(y - old_Y) Then
				delta = Abs(x - old_X)
				TotTime += CalcTime(delta, WorkFeed, RampX)
			Else
				delta = Abs(y - old_Y)
				TotTime += CalcTime(delta, WorkFeed, RampY)
			End If
			'
			TotMove += delta
			'
			old_X = x
			old_Y = y
			'
			Gcode.Add("G01 X" & FormatNum(x) & " Y" & FormatNum(y))
		End If
	End Sub

	Friend Sub MoveTo(ByVal z As Double)
		'
		Dim delta As Double
		'
		If z <> old_Z Then
			delta = Abs(z - old_Z)
			TotTime += CalcTime(delta, WorkFeed, RampZ)
			TotRapid += delta
			'
			old_Z = z
			'
			Gcode.Add("G01 Z" & FormatNum(z))
		End If
	End Sub

End Module