
' ================================================================================================
'  Theremino System - Voltage induced by a magnetic field
' ================================================================================================

Sub Form1_load(sender As Object, e As System.EventArgs) Handles Form1.load
	label1.text &= vbcrlf
	label1.text &= "Induced voltages"
	label1.text &= vbcrlf
	' -----------------------------------------------------------------------	
	'from http://www3.unisi.it/fisica/dip/dida/ctff/materiale/Magnetismo.pdf
	'PrintInducedVoltage(0.450 - 0.0125,  0.25, 40, 6.1)
	' -----------------------------------------------------------------------
	'                            
	PrintInducedVoltage(75e-12,  10e-6, 100, 2) ' strike at 700 Km = 75 pico tesla / 10 uS  100t 2cm
	PrintInducedVoltage(7.5e-9,  10e-6, 100, 2) ' strike at 7 Km = 7.5 nano tesla  / 10 uS  100t 2cm
	' with ferrite moltipliyng tourns * 10 
	PrintInducedVoltage(7.5e-9,  10e-6, 100 * 10, 2) ' strike at 7 Km = 7.5 nano tesla  / 10 uS  100t 2cm
End Sub

Sub PrintInducedVoltage(DeltaFieldTesla As Double, _
						DeltaTimeSeconds As Double, _
						Ntourns As Double, _
						DiamCm As Double)
	Dim Volt As Double = InducedVoltage(DeltaFieldTesla, DeltaTimeSeconds, Ntourns, DiamCm)										
	Dim s As String = StrDup(128, " ")
	If DeltaFieldTesla >= 1 Then
		mid(s,1) = DeltaFieldTesla.ToString("Tesla=0")
	Else If DeltaFieldTesla >= 1e-3 Then
		mid(s,1) = (DeltaFieldTesla * 1e3).ToString("MilliTesla=0")
	Else If DeltaFieldTesla >= 1e-6 Then
		mid(s,1) = (DeltaFieldTesla * 1e6).ToString("MicroTesla=0")
	Else If DeltaFieldTesla >= 1e-9 Then
		mid(s,1) = (DeltaFieldTesla * 1e9).ToString("NanoTesla=0")
	Else
		mid(s,1) = (DeltaFieldTesla * 1e12).ToString("PicoTesla=0")
	End If
	If DeltaTimeSeconds >= 1 Then
		mid(s,15) = DeltaTimeSeconds.ToString("Sec=0")
	Else If DeltaTimeSeconds >= 1e-3 Then
		mid(s,15) = (DeltaTimeSeconds * 1e3).ToString("MilliSec=0")
	Else
		mid(s,15) = (DeltaTimeSeconds * 1e6).ToString("MicroSec=0")
	End If
	mid(s,30) = ntourns.ToString("Ntourns=0")
	If Volt >= 1 Then
		mid(s,45) = Volt.ToString("Volt=0")
	Else If Volt >= 1e-3 Then
		mid(s,45) = (Volt * 1e3).ToString("MilliVolt=0")
	Else If Volt >= 1e-6 Then
		mid(s,45) = (Volt * 1e6).ToString("MicroVolt=0")
	Else If Volt >= 1e-9 Then
		mid(s,45) = (Volt * 1e9).ToString("NanoVolt=0")
	Else
		mid(s,45) = (Volt * 1e12).ToString("PicoVolt=0")
	End If
	'mid(s,40) = Volt.ToString("Volt=0.000")
	label1.text += (s + vbcrlf)
End Sub

Function InducedVoltage(DeltaFieldTesla As Double, _
						DeltaTimeSeconds As Double, _
						Ntourns As Double, _
						DiamCm As Double) As Double
	InducedVoltage = DeltaFieldTesla * Ntourns * PI *(DiamCm / 200)^2 / DeltaTimeSeconds
End Function


' ------------------------------------------------------------------------------------------------
'  Main Loop
' ------------------------------------------------------------------------------------------------
Sub Main(ByVal s() As String)
	If Form1 IsNot Nothing Then Return
	Form1 = New form
	InitializeComponents
	MemoryMappedFile_Init
	While Form1.Visible
		Application.DoEvents
		Threading.Thread.Sleep(10)
	End While
End Sub

Sub Form1_Closing(sender As Object, e As CancelEventArgs) Handles Form1.Closing

End Sub

Dim ValidKeyDown As Boolean = True
Sub Form1_KeyDown(sender As Object, e As System.Windows.Forms.KeyEventArgs) Handles Form1.KeyDown
	If e.KeyCode = Keys.Space And ValidKeyDown Then
		ValidKeyDown = False

	End If
End Sub
Sub Form1_KeyUp(sender As Object, e As System.Windows.Forms.KeyEventArgs) Handles Form1.KeyUp
	If e.KeyCode = Keys.Space Then
		ValidKeyDown = True
	End If
End Sub


' ---------------------------------------------------------------------- User Interface Components
Dim WithEvents Form1 As Form
Dim Label1 As Label = New Label
Dim WithEvents Button1 As Button = New Button

Sub InitializeComponents()
	Application.EnableVisualStyles
	form1.SuspendLayout
	' ------------------------------------------------------------------ Form
	Form1.Text = "Theremino Script - InducedVoltage"
	Form1.ClientSize = New System.Drawing.Size(520, 600)
	Form1.StartPosition = FormStartPosition.CenterScreen
	Form1.FormBorderStyle = FormBorderStyle.Sizable
	Form1.MaximizeBox = False
	Form1.KeyPreview = True
	' ------------------------------------------------------------------ Label 1
	Label1.BorderStyle = BorderStyle.Fixed3D
	Label1.Location = New Point(8, 8)
	Label1.Width = form1.clientsize.Width-16
	Label1.Height = form1.clientsize.Height-16
	Label1.Font = New Font("Courier New", 10 )
	Label1.Anchor = AnchorStyles.Top Or AnchorStyles.Left Or AnchorStyles.right Or AnchorStyles.bottom
	Form1.Controls.Add(Label1)
	' ------------------------------------------------------------------ 
	Form1.ResumeLayout
	Form1.PerformLayout()
	Form1.Show
End Sub






